// pages/cyRank/index.js
const app = getApp()
Page({
  data: {
    safeAreaTop:app.data.safeAreaTop,//距离上面的安全距离
    statusNavBarHeight:app.data.statusNavBarHeight,
    rankType:1,
    authorTypeFlag:false,
    authorTypeList:[{
      id:'',
      top_label:'全部'
    }],
    authorType:{
      id:'',
      top_label:'全部'
    },
    pagesize:20,
    hotList:[],
    containerScrollTop:0,
    isScroll:true,
    choiceType:1,
    timeList:[
      {label:1,value:'不限',start_time:'',end_time:'' },
      {label:2,value:'昨天',start_time:app.func.getDay(-1,false),end_time:''},
      {label:3,value:'近3天',start_time:app.func.getDay(-3,false),end_time:''},
      {label:4,value:'近7天',start_time:app.func.getDay(-7,false),end_time:'' },
      {label:5,value:'近15天',start_time:app.func.getDay(-15,false),end_time:'' },
      {label:6,value:'近30天',start_time:app.func.getDay(-30,false),end_time:'' },
    ],
    timeHotVideo:{label:1,value:'不限',start_time:'',end_time:'' },
    type_2_timeFlag:false,
    type_2_timeList:[app.func.getDay(0,false),app.func.getDay(-1,false),app.func.getDay(-2,false),app.func.getDay(-3,false),app.func.getDay(-4,false),app.func.getDay(-5,false),app.func.getDay(-6,false)],
    type_2_time:app.func.getDay(0,false),
    type_2_timeRangeList:[
      {id:1,name:'00:00 - 08:00'},
      {id:2,name:'08:00 - 16:00'},
      {id:3,name:'16:00 - 24:00'},
    ],
    type_2_timeRange:{id:1,name:'00:00 - 08:00'},
    type_2_keyword:'',
    videoIncrList:[],
    topicList:[],
    type_3_timeList:[
      {id:1,name:'昨天'},
      {id:3,name:'近3天'},
      {id:7,name:'近7天'},
      {id:15,name:'近15天'},
      {id:30,name:'近30天'},
    ],
    type_3_time:{id:1,name:'昨天'},
    type_3_timeFlag:false,
    type_3_keyword:'',
    loading:true,
    page:1,
    total:0,
    isHaveMoreData:true,
    type_4_keyword:'',
    type_4_keyword2:'',
    type_4_timeFlag:false,
    type_4_timeList: [
      {label:1,value:'近3天',start_time:app.func.getDay(-3,false),end_time:app.func.getDay(0,false)},
      {label:2,value:'近7天',start_time:app.func.getDay(-7,false),end_time:app.func.getDay(0,false) },
      {label:3,value:'近15天',start_time:app.func.getDay(-15,false),end_time:app.func.getDay(0,false) },
      {label:4,value:'近30天',start_time:app.func.getDay(-30,false),end_time:app.func.getDay(0,false) },
    ],
    type_4_time:{label:1,value:'近3天',start_time:app.func.getDay(-3,false),end_time:app.func.getDay(0,false)},
    type_4_totalData:{},
    type_4_infoList:[],
    type_4_dayTrend:[],
    type_4_trendFlag:true,
    scrollTop:0,
  },
  onLoad: function (options) {
    this.setData({
      page: 1,
      hotList: [],
      authorTypeList: [],
    })
    this.getAuthorType()
    this.init()
  },
  onShow: function () {
  },
  init(source){
    if(source!='xiala'){
      this.setData({
        rankType:app.data.cyRank_type
      })
    }
    if(this.data.rankType==1){
      this.getHotList(1)
    }
    if(this.data.rankType==2){
      this.getVideoIncrList(1)
    }
    if(this.data.rankType==3){
      this.getTopicList(1)
    }
    this.goScrolltop()
  },
  getAuthorType(){//获取作者类别
    app.func.req('/api/sphUserList/labelList', 'get', {
    }, (res) => {
      if(res && res.errno == 0){
        this.setData({
          authorTypeList:res.rst
        })
      }else{
        swan.showToast({
          title: res.err,
          icon: 'none',
          duration: 2000
        })
      }
    },()=>{
    })
  },
  getHotList(page){//热门视频
    swan.showLoading({
      title: '加载中',
    })
    this.setData({
      loading:true,
      page:page
    })
    app.func.req('/api/sphVideo/hotList', 'get', {
      page:page,
      sign_id:this.data.authorType.id,
      start_time:this.data.timeHotVideo.start_time,
      end_time:this.data.timeHotVideo.end_time,
      pagesize:this.data.pagesize,
    }, (res) => {
      swan.hideLoading()
      swan.stopPullDownRefresh()
      if(res && res.errno == 0){
        //成功
        if(page==1){
          this.setData({
            containerScrollTop:0,
            hotList:[],
            total:0
          })
        }
        this.setData({
          hotList:this.data.hotList.concat(res.rst.data),
          total:res.rst.pageInfo.total,
          loading:false
        })
        if(this.data.page*this.data.pagesize>=this.data.total){
          this.setData({
            isHaveMoreData:false
          })
        }else{
          this.setData({
            isHaveMoreData:true
          })
        }
      }else{
        this.setData({
          loading:false
        })
        swan.showToast({
          title: res.err,
          icon: 'none',
          duration: 2000
        })
      }
    },()=>{
      swan.stopPullDownRefresh()
      this.setData({
        loading:false
      })
      swan.hideLoading()
    })
  },
  getVideoIncrList(page){//暴涨视频
    swan.showLoading({
      title: '加载中',
    })
    this.setData({
      loading:true,
      page:page
    })
    app.func.req('/api/sphVideo/videoIncrList', 'get', {
      page:page,
      date:this.data.type_2_time,
      type:this.data.type_2_timeRange.id,
      end_time:this.data.timeHotVideo.end_time,
      page_size:this.data.pagesize,
      sort:'like_add',
      keyword:this.data.type_2_keyword
    }, (res) => {
      swan.hideLoading()
      swan.stopPullDownRefresh()
      if(res && res.errno == 0){
        //成功
        if(page==1){
          this.setData({
            containerScrollTop:0,
            videoIncrList:[],
            total:0
          })
        }
        this.setData({
          loading:false,
          videoIncrList:this.data.videoIncrList.concat(res.rst.data),
          total:res.rst.pageInfo.total
        })
        if(this.data.page*this.data.pagesize>=this.data.total){
          this.setData({
            isHaveMoreData:false
          })
        }else{
          this.setData({
            isHaveMoreData:true
          })
        }
      }else{
        this.setData({
          loading:false
        })
        swan.showToast({
          title: res.err,
          icon: 'none',
          duration: 2000
        })
      }
    },()=>{
      this.setData({
        loading:false
      })
      swan.stopPullDownRefresh()
      swan.hideLoading()
    })
  },
  // 详情跳转
  toDetail(e) {
    swan.navigateTo({
      url: '/pages/videoDetail/videoDetail?video_id='+e.currentTarget.dataset.item.video_id+'&user_id='+e.currentTarget.dataset.item.user_id,
    })
  },
  goVideoDetail(e){
    swan.navigateTo({
      url: '/pages/videoDetail/videoDetail?video_id='+e.currentTarget.dataset.item.video_id+'&user_id='+e.currentTarget.dataset.item.user_id,
    })
  },
  getTopicList(page){//话题标签
      swan.showLoading({
        title: '加载中',
      })
      this.setData({
        loading:true,
        page:page
      })
      app.func.req('/api/search/hotTopic', 'post', {
        page:page,
        page_size:this.data.pagesize,
        type:this.data.type_3_time.id,
        keyword:this.data.type_3_keyword
      }, (res) => {
      swan.stopPullDownRefresh()
      swan.hideLoading()
        if(res && res.errno == 0){
          //成功
          if(page==1){
            this.setData({
              containerScrollTop:0,
              topicList:[],
              total:0
            })
          }
          this.setData({
            loading:false,
            topicList:this.data.topicList.concat(res.rst.data),
            total:res.rst.pageInfo.total
          })
          if(this.data.page*this.data.pagesize>=this.data.total){
            this.setData({
              isHaveMoreData:false
            })
          }else{
            this.setData({
              isHaveMoreData:true
            })
          }
        }else{
          this.setData({
            loading:false
          })
          swan.showToast({
            title: res.err,
            icon: 'none',
            duration: 2000
          })
        }
      },()=>{
        this.setData({
          loading:false
        })
      swan.stopPullDownRefresh()
      swan.hideLoading()
      })
  },
  timeChoiceClick(e){//点击热门视频搜索条件
    var data = e.currentTarget.dataset;
    if((this.data.choiceType == 2 && data.type == 2)||(this.data.choiceType != data.type && data.type == 2)){
      this.setData({
        authorTypeFlag: !this.data.authorTypeFlag,
        timeFlag:false
      })
    }
    if((this.data.choiceType != data.type && data.type == 1) || (this.data.choiceType == 1 && data.type == 1)){
      this.setData({
        timeFlag: !this.data.timeFlag,
        authorTypeFlag:false
      })
    }
    this.setData({
      choiceType:data.type
    })
    if(!this.data.timeFlag && !this.data.authorTypeFlag){
      this.setData({
        isScroll:true
      })
    }
    if(this.data.timeFlag || this.data.authorTypeFlag){
      this.setData({
        isScroll:false
      })
    }
  },
  authorTypeClick(e){
    var data = e.currentTarget.dataset;
    if(data.info.id != this.data.authorType.id){
      this.setData({
        authorType:data.info
      })
      this.getHotList(1)
    }
    this.closeToast()
  },
  closeToast(){//关闭弹框
    this.setData({
      authorTypeFlag:false,
      timeFlag: false,
      isScroll:true,
      type_2_timeFlag:false,
      type_3_timeFlag:false,
      type_4_timeFlag:false
    })
  },
  cycle_1_click(e){
    var data  = e.currentTarget.dataset
    if(this.data.timeHotVideo.label != data.info.label){
      this.setData({
        timeHotVideo:data.info
      })
      this.getHotList(1)
    }
    this.closeToast()
  },
  rankTypeClick(e){//头部榜单type
    var data = e.currentTarget.dataset
    if(data.type == this.data.rankType){
      return;
    }
    this.setData({
      containerScrollTop:0,
      rankType:data.type
    })
    app.data.cyRank_type = data.type
    if(data.type==1){
      this.getHotList(1)
    }
    if(data.type==2){
      this.getVideoIncrList(1)
    }
    if(data.type==3){
      this.getTopicList(1)
    }
    this.goScrolltop()
  },
  type_2_timeChoiceClick(){
    this.setData({
      type_2_timeFlag:!this.data.type_2_timeFlag
    })
  },
  type_2_cycleEvent(e){
    var data = e.currentTarget.dataset
    if(this.data.type_2_time == data.info){
      return;
    }
    this.setData({
      type_2_time:data.info,
      type_2_timeRange:{id:1,name:'00:00 - 08:00'},
    })
    this.getVideoIncrList(1)
  },
  type_2_click(e){
    var data = e.currentTarget.dataset
    if(this.data.type_2_timeRange.id == data.info.id){
      return;
    }
    this.setData({
      type_2_timeRange:data.info
    })
    this.getVideoIncrList(1)
    this.closeToast()
  },
  type_2_bindKeyInput(e){
    this.setData({
      type_2_keyword: e.detail.value
    })
  },
  type_2_search_confirm(){
    this.getVideoIncrList(1)
    this.closeToast()
  },
  type_3_bindKeyInput(e){
    this.setData({
      type_3_keyword: e.detail.value
    })
  },
  type_3_search_confirm(){
    this.getTopicList(1)
    this.closeToast()
  },
  type_3_timeChoiceClick(){
    this.setData({
      type_3_timeFlag:!this.data.type_3_timeFlag
    })
  },
  type_3_click(e){
    var data = e.currentTarget.dataset;
    if(data.info.id == this.data.type_3_time.id){
      return
    }
    this.setData({
      type_3_time:data.info
    })
    this.getTopicList(1)
    this.closeToast()
  },
  type_4_click(e){
    var data = e.currentTarget.dataset;
    if(data.info.label == this.data.type_4_time.label){
      return
    }
    this.setData({
      type_4_time:data.info
    })
    this.closeToast()
  },
  type_4_search_confirm(){
    this.closeToast()
  },
  type_4_bindKeyInput(e){
    this.setData({
      type_4_keyword: e.detail.value
    })
  },
  type_4_bindKeyInput2(e){
    this.setData({
      type_4_keyword2: e.detail.value
    })
  },
  type_4_timeChoiceClick(){
    this.setData({
      type_4_timeFlag:!this.data.type_4_timeFlag
    })
  },

  goSearch() {
    swan.navigateTo({
      url: '/pages/search/search',
    })
  },
  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {
    this.init('xiala')
  },
  onPageScroll: function(res) {//获取滑动的距离
    this.setData({
      scrollTop:res.scrollTop
    })
  },
  goScrolltop:function(e){//返回顶部
    if (swan.pageScrollTo) {
      swan.pageScrollTo({
        scrollTop: 0
      })
    } else {
      swan.showModal({
        title: '提示',
        content: '当前微信版本过低，无法使用该功能，请升级到最新微信版本后重试。'
      })
    }
  },
  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {
    if(this.data.loading){
      return;
    }
    if(this.data.rankType==4){
      return;
    }
    if(this.data.page * this.data.pagesize < this.data.total){
      this.setData({
        page:this.data.page+1,
        isHaveMoreData:true
      })
      if(this.data.rankType==1){
        this.getHotList(this.data.page)
      }
      if(this.data.rankType==2){
        this.getVideoIncrList(this.data.page)
      }
      if(this.data.rankType==3){
        this.getTopicList(this.data.page)
      }
    }else{
      this.setData({
        isHaveMoreData:false
      })
    }
  },
  toTopic(e) {
    swan.navigateTo({
      url: '/pages/topicDetail/topicDetail?name='+e.currentTarget.dataset.item.topic_name,
    })
  },
  onShareAppMessage(res) {
    return app.shareEvent(res)
  }
})