// pages/mine/mine.js
const app = getApp()
Page({

  /**
   * 页面的初始数据
   */
  data: {
    safeAreaTop: '',
    userInfo: {},
    writePhotosFlag:-1,
    qunFlag:false
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    this.init()
    this.setData({
      safeAreaTop:50+app.data.safeAreaTop,
      userInfo: swan.getStorageSync('userInfo')
    })
  },
  onShow: function(){
    this.init()
  },
  init(){
    var _this = this;
    swan.getSetting({
      success(res) {
        if(res.authSetting['scope.writePhotosAlbum'] == false){
        }
        if(res.authSetting['scope.writePhotosAlbum'] == true){
          _this.setData({writePhotosFlag:true})
        }
      }
    })
  },
  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },
  cancelTask(){
    this.setData({qunFlag:false})
  },
  copyEvent(){
    swan.setClipboardData({
      data: 'https://www.wenxingshuju.com',
      success: function (res) {
        swan.getClipboardData({
          success: function (res) {
            swan.showToast({
              title: '复制成功'
            })
          }
        })
      }
    })
  },
  toUrl(e) {
    if(e.currentTarget.dataset.path.indexOf('allNotice')!=-1) {
      swan.switchTab({
        url: '/pages/newNotice/allNotice/allNotice'
      })
    }else {
      swan.navigateTo({
        url: e.currentTarget.dataset.path
      })
    }
  },
  goPageClaim(){
    swan.navigateTo({
      url: '/pages/claim/index/index',
    })
  },
  qunEvent(){
    this.setData({qunFlag:true})
  },
  downLoadImgEvent(){
    if(!this.data.writePhotosFlag){
      swan.openSetting()
      return
    }
    var _this = this;
    swan.getSetting({
      success(res) {
        if (!res.authSetting['scope.writePhotosAlbum']) {
          swan.authorize({
            scope:'scope.writePhotosAlbum',
            success() {//授权成功
              _this.setData({writePhotosFlag:true})
              _this.downloadImg()
            },
            fail:function(err){
              _this.setData({writePhotosFlag:false})
            },
          })
        }else{//已经授权
          _this.setData({writePhotosFlag:true})
          _this.downloadImg()
        }
      }
    })
  },
  downloadImg(){
    var imgSrc = "https://www.wenxingshuju.com/kol_wx_qun_evm.jpg"
    swan.downloadFile({
      url: imgSrc,
      success: function (res) {
        swan.saveImageToPhotosAlbum({
          filePath: res.tempFilePath,
          success: function (data) {
            swan.showToast({
              title: '保存成功',
              icon: 'success',
              duration: 2000
            })
          },
          fail: function (err) {
          },
          complete(res){
         }
        })
      }
    })
  },
  goWebView(){
    swan.navigateTo({
      url: '/pages/webView/index',
    })
  },
  onShareAppMessage(res){
    return app.shareEvent(res)
   }
})